<template>
	<div class="q-py-md">
		<div class="q-gutter-x-md q-mx-md q-mb-lg">
			<q-btn-toggle
				dense
				class="outline-btn"
				unelevated
				text-color="grey"
				ref="paginateBtn"
				v-model="viewingState"
				toggle-color="primary"
				:options="[{ icon: 'grid_on', value: 'pagination' }]"
			/>

			<span>Pagination Mode</span>

			<q-btn-toggle
				id="btnToggle"
				ref="scrollBtn"
				dense
				class="outline-btn"
				unelevated
				text-color="grey"
				v-model="viewingState"
				toggle-color="primary"
				:options="[{ icon: 'view_list', value: 'scrolling' }]"
			/>

			Scroll Mode
		</div>

		<paginate-viewing v-if="!loading && viewingState === 'pagination'" />

		<scroll-viewing v-if="!loading && viewingState === 'scrolling'" />
		<skeleton-card-loader v-if="loading" :containerRepeat="cardLoadingCount" />
	</div>
</template>

<script>
	import { mapActions, mapGetters, mapMutations } from "vuex";
	import SkeletonCardLoader from "src/components/layouts/SkeletonCardLoader.vue";
	import NotFound from "src/components/pokemon/NotFound.vue";
	import ScrollViewing from "src/components/layouts/ScrollViewing.vue";
	import PaginateViewing from "src/components/layouts/PaginateViewing.vue";
	export default {
		components: {
			SkeletonCardLoader,
			NotFound,
			ScrollViewing,
			PaginateViewing,
		},
		name: "PageIndex",
		data: () => ({
			viewingState: "pagination",
		}),

		created() {
			this.handleonCreated();
		},

		methods: {
			...mapActions("pokemon", ["fetchData"]),
			...mapMutations("pokemon", ["toggleLoading", "clearPokemon"]),
			async handleonCreated() {
				this.toggleLoading();
				await this.fetchData({ type: "pagination" });
				this.toggleLoading();
			},
		},

		computed: {
			...mapGetters("pokemon", [
				"pokemons",
				"urlApi",
				"totalPokemons",
				"loading",
			]),

			totalPokemons() {
				return this.pokemons.length;
			},

			cardLoadingCount() {
				if (this.$q.screen.gt.sm) return 4;
				return 2;
			},
		},

		watch: {
			viewingState() {
				this.clearPokemon();
				this.fetchData();
			},
		},
	};
</script>
